#!/usr/bin/python3
# -*- coding: utf-8 -*-


import sys

OK = 0
PE = 4
WA = 5
CF = 6
AC = 8

def quit(status, log="", score=0):
    # Если задано значение параметра log, то выводится это значение, иначе выводится глобальная переменная LOG
    
    ## Заглушка ##
    #if status != PE:
    #    log = "Полные протоколы проверки будут доступны после перетестирования"
    if (status == CF):
        sys.stderr.write("points "+ str(score) + "\n" + log)
        sys.exit(status)
    sys.stdout.write("points " + str(score) + "\n")
    if (status == PE):
        sys.stderr.write("points "+ str(score) + "\n" + log)
        if len(log) > 0 and log[0] != '!':
            sys.exit(OK)
    if status == OK:
        sys.stderr.write("points " + str(score) + "\n" + log)
        status = OK
    sys.exit(status)


class Field():
    def __init__(self, n):
        self.field = [list(map(int, input().split())) for i in range(n)]
        self.prev_color = -1
        self.prev_row = -1
        self.size = n
    def mirror(self):
        for i in range(self.size):
            for j in range(i + 1, self.size):
                self.field[i][j], self.field[j][i] = self.field[j][i], self.field[i][j]

    def shift(self, num, column, amount):
        if (not 0 < num <= self.size):
            print("Invalid position", file=sys.stderr)
            sys.exit(1)
        num -= 1
        if (not (0 < amount < self.size)):
            if (amount != 0):
                print("amount check failed", file=sys.stderr)
                sys.exit(PE)
        if (column in "UD"):
            x = [self.field[i][num] for i in range(self.size)] 
            if (column == "D"):
                x = x[-amount:] + x[:-amount]
            if (column == "U"):
                x = x[amount:] + x[:amount]
            for i in range(self.size): self.field[i][num] = x[i] 
        elif (column in "LR"):
            if (column == "R"):
                self.field[num] = self.field[num][-amount:] + self.field[num][:-amount]
            if (column == "L"):
                self.field[num] = self.field[num][amount:] + self.field[num][:amount]
        else:
            sys.exit(CF, "неизвестная ошибка")
        #print(num, column, amount, file=sys.stderr)
    def __field_checker(self):
        for i in self.field:
            if (len(set(i)) != 1):
                return False
        return True
    def check_field(self):
        x = self.__field_checker()
        self.mirror()
        x |= self.__field_checker()
        self.mirror()
        return x
    def __str__(self):
        return '\n'.join(map(lambda x: ' '.join(map(str, x)), self.field))

def check(testnum):
    global glscore
    n = int(input())
    f = Field(n) #input
    try: answer = int(ans.readline()) #output
    except: quit(PE, "Не смог прочитать тест" + str(testnum), glscore)
    jury_answer = int(best.readline()) #answer
    for i in range(jury_answer):
        best.readline()
    for i in range(answer):
        try:
            line, direction, length = (lambda x: (int(x[0]), x[1], int(x[2])))(ans.readline().strip().split())
        except:
            quit(PE, "Нарушен формат ввода в подтесте {} в строке {}/{}\n".format(testnum, i + 1, answer), glscore)
        
        #print(f"{i + 1}/{answer}")
        #print("--- --- ---")
        #print(f)
        #print("--- --- ---")
        #print(line, direction, length)

        if (not (0 < line <= n)):
            quit(PE, "В тесте {} в строке {} первый параметр не удовлетворяет ограничениям".format(testnum, i + 1))
        if (direction not in {'U', 'D', 'L', 'R'}):
            quit(PE, "В тесте {} в строке {} второй параметр не удовлетворяет ограничениям".format(testnum, i + 1))
        if (not (0 < length <= n)):
            if (length != 0):
                quit(PE, "В тесте {} в строке {} третий параметр не удовлетворяет ограничениям".format(testnum, i + 1))
        f.shift(line, direction, length)
    score = 10
    #print("--- --- ---")
    #print(f)
    #print("--- --- ---")
    if (not f.check_field()):
        score *= 0
    else:
        if (answer < jury_answer):
            quit(CF, "Участник имеет решение лучше в тесте {}".format(testnum))
        score = 2.5 + 7.5 * jury_answer / answer 
    return score


sys.stdin = open(sys.argv[1], 'r')
ans = open(sys.argv[2], 'r')
best = open(sys.argv[3], 'r')
s = int(input())
log = ""
sysout = 0
try:
    if (int(ans.readline()) != s):
        print("participant not full test")
        sysout = 1
except:
    quit(PE, "! Не смог прочитать первую строку")
if (sysout): sys.exit(PE)

if (int(best.readline()) != s):
    print("jury format error")
    sys.exit(1)
glscore = 0
for i in range(1, s + 1):
    test_score = check(i)
    log += "Test {}: {} ".format(i, test_score) + ("" if test_score != 0 else "Квадрат не был собран") + "\n"
    glscore += test_score
quit(OK, log, glscore)
